%    This library is free software; you can redistribute it and/or
%    modify it under the terms of the GNU Lesser General Public
%    License as published by the Free Software Foundation; either
%    version 2.1 of the License, or (at your option) any later version.

%    This library is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%    Lesser General Public License for more details.

%    You should have received a copy of the GNU Lesser General Public License 
%    (lgpl_license.txt) along with this library; if not, write to the Free Software
%    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

function [aspect_ratio] = compute_aspect_ratio2(coords);

x1=coords.x1;
x2=coords.x2;
x3=coords.x3;
y1=coords.y1;
y2=coords.y2;
y3=coords.y3;

a=sqrt((x1-x2)^2+(y1-y2)^2);
b=sqrt((x2-x3)^2+(y2-y3)^2);
c=sqrt((x1-x3)^2+(y1-y3)^2);

s=0.5*(a+b+c);

prod=(s-a)*(s-b)*(s-c);

CR = (a*b*c)/(4*sqrt(s*prod));
IR = sqrt(prod/s);

aspect_ratio = CR/IR;
